<?php

/**
 * anual_etapa_cc_etapa actions.
 *
 * @package    canon
 * @subpackage anual_etapa_cc_etapa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class anual_etapa_cc_etapaActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $whereEtapa = ' ';
            if (isset($request['id_etapa'])) {
                $whereEtapa = " AND tab0.id_etapa = '" . $request['id_etapa'] . "' ";
            }
            
            if (isset($request['actual'])) {
                $whereActual = " AND tab0.actual = '" . $request['actual'] . "' ";
            }
        
            if (isset($request['id_titulo'])) {
                $whereTitulo = "AND tab0.id_titulo= '" . $request['id_titulo'] . "' ";
                
            }
            $whereNovedad = ' ';
            if (isset($request['id_novedad'])) {
                $whereNovedad = " AND tab0.id_novedad = '" . $request['id_novedad'] . "' ";
                $id_nov = $request['id_novedad'];
            }
            
            /*
             * Sql que trae la fila de la etapa acual
             */
            $sql = <<<EOD
select count(*) as count from(

SELECT DISTINCT  tab0.id_etapa as id_etapa, tab2.nombre as nombre, tab2.descripcion as descripcion  

FROM CA_TITULO_ETAPA tab0  LEFT JOIN CA_ANUAL_ETAPA tab1 ON tab0.id_titulo_etapa = tab1.id_titulo_etapa  
                
LEFT JOIN CA_ETAPA tab2 ON tab0.id_etapa = tab2.id_etapa 
               
WHERE 1=1 and tab1.liquidado=0 $whereTitulo  $whereActual 

order by tab0.id_etapa
  
)tabla
EOD;
//AND tab0.fecha_fin > sysdate
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            if ($total_record_count > 0) {

                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
            
SELECT DISTINCT  tab0.id_etapa as id_etapa, tab2.nombre as nombre, tab2.descripcion as descripcion  

FROM CA_TITULO_ETAPA tab0  LEFT JOIN CA_ANUAL_ETAPA tab1 ON tab0.id_titulo_etapa = tab1.id_titulo_etapa  
                
LEFT JOIN CA_ETAPA tab2 ON tab0.id_etapa = tab2.id_etapa 
               
WHERE 1=1 and tab1.liquidado=0 $whereTitulo  $whereActual 

order by tab0.id_etapa
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
//AND tab0.fecha_fin > sysdate

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                   // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_titulo_etapa');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
           
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[CC_ETAPA_SIG] Consulta exitosa.");
            }else{
               $this->status = 0;
               $this->list_data = array();
               $this->logMessage("[CC_ETAPA_SIG] No hay registros.");
            }
            
        } catch (Exception $e) {
               $this->status = -1;
               $this->list_data = array();
               $this->logMessage("[CC_ETAPA_SIG] Consulta Erronea.");
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
